import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#api_id Apigatewayv2IntegrationResponse#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#content_handling_strategy Apigatewayv2IntegrationResponse#content_handling_strategy}.
     *
     * @stability stable
     */
    readonly contentHandlingStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#integration_id Apigatewayv2IntegrationResponse#integration_id}.
     *
     * @stability stable
     */
    readonly integrationId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#integration_response_key Apigatewayv2IntegrationResponse#integration_response_key}.
     *
     * @stability stable
     */
    readonly integrationResponseKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#response_templates Apigatewayv2IntegrationResponse#response_templates}.
     *
     * @stability stable
     */
    readonly responseTemplates?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#template_selection_expression Apigatewayv2IntegrationResponse#template_selection_expression}.
     *
     * @stability stable
     */
    readonly templateSelectionExpression?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html aws_apigatewayv2_integration_response}.
 *
 * @stability stable
 */
export declare class Apigatewayv2IntegrationResponse extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html aws_apigatewayv2_integration_response} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2IntegrationResponseConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    private _contentHandlingStrategy?;
    /**
     * @stability stable
     */
    get contentHandlingStrategy(): string;
    /**
     * @stability stable
     */
    set contentHandlingStrategy(value: string);
    /**
     * @stability stable
     */
    resetContentHandlingStrategy(): void;
    /**
     * @stability stable
     */
    get contentHandlingStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _integrationId;
    /**
     * @stability stable
     */
    get integrationId(): string;
    /**
     * @stability stable
     */
    set integrationId(value: string);
    /**
     * @stability stable
     */
    get integrationIdInput(): string;
    private _integrationResponseKey;
    /**
     * @stability stable
     */
    get integrationResponseKey(): string;
    /**
     * @stability stable
     */
    set integrationResponseKey(value: string);
    /**
     * @stability stable
     */
    get integrationResponseKeyInput(): string;
    private _responseTemplates?;
    /**
     * @stability stable
     */
    get responseTemplates(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseTemplates(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseTemplates(): void;
    /**
     * @stability stable
     */
    get responseTemplatesInput(): {
        [key: string]: string;
    } | undefined;
    private _templateSelectionExpression?;
    /**
     * @stability stable
     */
    get templateSelectionExpression(): string;
    /**
     * @stability stable
     */
    set templateSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetTemplateSelectionExpression(): void;
    /**
     * @stability stable
     */
    get templateSelectionExpressionInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
