import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2StageConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#api_id Apigatewayv2Stage#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#auto_deploy Apigatewayv2Stage#auto_deploy}.
     *
     * @stability stable
     */
    readonly autoDeploy?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#client_certificate_id Apigatewayv2Stage#client_certificate_id}.
     *
     * @stability stable
     */
    readonly clientCertificateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#deployment_id Apigatewayv2Stage#deployment_id}.
     *
     * @stability stable
     */
    readonly deploymentId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#description Apigatewayv2Stage#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#name Apigatewayv2Stage#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#stage_variables Apigatewayv2Stage#stage_variables}.
     *
     * @stability stable
     */
    readonly stageVariables?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#tags Apigatewayv2Stage#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#tags_all Apigatewayv2Stage#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * access_log_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#access_log_settings Apigatewayv2Stage#access_log_settings}
     *
     * @stability stable
     */
    readonly accessLogSettings?: Apigatewayv2StageAccessLogSettings[];
    /**
     * default_route_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#default_route_settings Apigatewayv2Stage#default_route_settings}
     *
     * @stability stable
     */
    readonly defaultRouteSettings?: Apigatewayv2StageDefaultRouteSettings[];
    /**
     * route_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#route_settings Apigatewayv2Stage#route_settings}
     *
     * @stability stable
     */
    readonly routeSettings?: Apigatewayv2StageRouteSettings[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageAccessLogSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#destination_arn Apigatewayv2Stage#destination_arn}.
     *
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#format Apigatewayv2Stage#format}.
     *
     * @stability stable
     */
    readonly format: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageDefaultRouteSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#data_trace_enabled Apigatewayv2Stage#data_trace_enabled}.
     *
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#detailed_metrics_enabled Apigatewayv2Stage#detailed_metrics_enabled}.
     *
     * @stability stable
     */
    readonly detailedMetricsEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#logging_level Apigatewayv2Stage#logging_level}.
     *
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_burst_limit Apigatewayv2Stage#throttling_burst_limit}.
     *
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_rate_limit Apigatewayv2Stage#throttling_rate_limit}.
     *
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageRouteSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#data_trace_enabled Apigatewayv2Stage#data_trace_enabled}.
     *
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#detailed_metrics_enabled Apigatewayv2Stage#detailed_metrics_enabled}.
     *
     * @stability stable
     */
    readonly detailedMetricsEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#logging_level Apigatewayv2Stage#logging_level}.
     *
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#route_key Apigatewayv2Stage#route_key}.
     *
     * @stability stable
     */
    readonly routeKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_burst_limit Apigatewayv2Stage#throttling_burst_limit}.
     *
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_rate_limit Apigatewayv2Stage#throttling_rate_limit}.
     *
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html aws_apigatewayv2_stage}.
 *
 * @stability stable
 */
export declare class Apigatewayv2Stage extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html aws_apigatewayv2_stage} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2StageConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoDeploy?;
    /**
     * @stability stable
     */
    get autoDeploy(): boolean;
    /**
     * @stability stable
     */
    set autoDeploy(value: boolean);
    /**
     * @stability stable
     */
    resetAutoDeploy(): void;
    /**
     * @stability stable
     */
    get autoDeployInput(): boolean | undefined;
    private _clientCertificateId?;
    /**
     * @stability stable
     */
    get clientCertificateId(): string;
    /**
     * @stability stable
     */
    set clientCertificateId(value: string);
    /**
     * @stability stable
     */
    resetClientCertificateId(): void;
    /**
     * @stability stable
     */
    get clientCertificateIdInput(): string | undefined;
    private _deploymentId?;
    /**
     * @stability stable
     */
    get deploymentId(): string;
    /**
     * @stability stable
     */
    set deploymentId(value: string);
    /**
     * @stability stable
     */
    resetDeploymentId(): void;
    /**
     * @stability stable
     */
    get deploymentIdInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeUrl(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _stageVariables?;
    /**
     * @stability stable
     */
    get stageVariables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set stageVariables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetStageVariables(): void;
    /**
     * @stability stable
     */
    get stageVariablesInput(): {
        [key: string]: string;
    } | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _accessLogSettings?;
    /**
     * @stability stable
     */
    get accessLogSettings(): Apigatewayv2StageAccessLogSettings[];
    /**
     * @stability stable
     */
    set accessLogSettings(value: Apigatewayv2StageAccessLogSettings[]);
    /**
     * @stability stable
     */
    resetAccessLogSettings(): void;
    /**
     * @stability stable
     */
    get accessLogSettingsInput(): Apigatewayv2StageAccessLogSettings[] | undefined;
    private _defaultRouteSettings?;
    /**
     * @stability stable
     */
    get defaultRouteSettings(): Apigatewayv2StageDefaultRouteSettings[];
    /**
     * @stability stable
     */
    set defaultRouteSettings(value: Apigatewayv2StageDefaultRouteSettings[]);
    /**
     * @stability stable
     */
    resetDefaultRouteSettings(): void;
    /**
     * @stability stable
     */
    get defaultRouteSettingsInput(): Apigatewayv2StageDefaultRouteSettings[] | undefined;
    private _routeSettings?;
    /**
     * @stability stable
     */
    get routeSettings(): Apigatewayv2StageRouteSettings[];
    /**
     * @stability stable
     */
    set routeSettings(value: Apigatewayv2StageRouteSettings[]);
    /**
     * @stability stable
     */
    resetRouteSettings(): void;
    /**
     * @stability stable
     */
    get routeSettingsInput(): Apigatewayv2StageRouteSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
