import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#mesh_name AppmeshRoute#mesh_name}.
     *
     * @stability stable
     */
    readonly meshName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#mesh_owner AppmeshRoute#mesh_owner}.
     *
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tags AppmeshRoute#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tags_all AppmeshRoute#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_router_name AppmeshRoute#virtual_router_name}.
     *
     * @stability stable
     */
    readonly virtualRouterName: string;
    /**
     * spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#spec AppmeshRoute#spec}
     *
     * @stability stable
     */
    readonly spec: AppmeshRouteSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecGrpcRouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#end AppmeshRoute#end}.
     *
     * @stability stable
     */
    readonly end: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#start AppmeshRoute#start}.
     *
     * @stability stable
     */
    readonly start: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadataMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#exact AppmeshRoute#exact}.
     *
     * @stability stable
     */
    readonly exact?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#regex AppmeshRoute#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#suffix AppmeshRoute#suffix}.
     *
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#range AppmeshRoute#range}
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadata {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#invert AppmeshRoute#invert}.
     *
     * @stability stable
     */
    readonly invert?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecGrpcRouteMatchMetadataMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#method_name AppmeshRoute#method_name}.
     *
     * @stability stable
     */
    readonly methodName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#service_name AppmeshRoute#service_name}.
     *
     * @stability stable
     */
    readonly serviceName?: string;
    /**
     * metadata block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#metadata AppmeshRoute#metadata}
     *
     * @stability stable
     */
    readonly metadata?: AppmeshRouteSpecGrpcRouteMatchMetadata[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#grpc_retry_events AppmeshRoute#grpc_retry_events}.
     *
     * @stability stable
     */
    readonly grpcRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_retry_events AppmeshRoute#http_retry_events}.
     *
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#max_retries AppmeshRoute#max_retries}.
     *
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_retry_events AppmeshRoute#tcp_retry_events}.
     *
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_retry_timeout AppmeshRoute#per_retry_timeout}
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeoutPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecGrpcRouteTimeoutIdle[];
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_request AppmeshRoute#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecGrpcRouteTimeoutPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecGrpcRouteAction[];
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecGrpcRouteMatch[];
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#retry_policy AppmeshRoute#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecGrpcRouteRetryPolicy[];
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecGrpcRouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecHttp2RouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#end AppmeshRoute#end}.
     *
     * @stability stable
     */
    readonly end: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#start AppmeshRoute#start}.
     *
     * @stability stable
     */
    readonly start: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeaderMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#exact AppmeshRoute#exact}.
     *
     * @stability stable
     */
    readonly exact?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#regex AppmeshRoute#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#suffix AppmeshRoute#suffix}.
     *
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#range AppmeshRoute#range}
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#invert AppmeshRoute#invert}.
     *
     * @stability stable
     */
    readonly invert?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecHttp2RouteMatchHeaderMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#method AppmeshRoute#method}.
     *
     * @stability stable
     */
    readonly method?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#scheme AppmeshRoute#scheme}.
     *
     * @stability stable
     */
    readonly scheme?: string;
    /**
     * header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#header AppmeshRoute#header}
     *
     * @stability stable
     */
    readonly header?: AppmeshRouteSpecHttp2RouteMatchHeader[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_retry_events AppmeshRoute#http_retry_events}.
     *
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#max_retries AppmeshRoute#max_retries}.
     *
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_retry_events AppmeshRoute#tcp_retry_events}.
     *
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_retry_timeout AppmeshRoute#per_retry_timeout}
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeoutPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecHttp2RouteTimeoutIdle[];
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_request AppmeshRoute#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecHttp2RouteTimeoutPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2Route {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecHttp2RouteAction[];
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshRouteSpecHttp2RouteMatch[];
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#retry_policy AppmeshRoute#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecHttp2RouteRetryPolicy[];
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecHttp2RouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecHttpRouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeaderMatchRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#end AppmeshRoute#end}.
     *
     * @stability stable
     */
    readonly end: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#start AppmeshRoute#start}.
     *
     * @stability stable
     */
    readonly start: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeaderMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#exact AppmeshRoute#exact}.
     *
     * @stability stable
     */
    readonly exact?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#regex AppmeshRoute#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#suffix AppmeshRoute#suffix}.
     *
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#range AppmeshRoute#range}
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#invert AppmeshRoute#invert}.
     *
     * @stability stable
     */
    readonly invert?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecHttpRouteMatchHeaderMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#method AppmeshRoute#method}.
     *
     * @stability stable
     */
    readonly method?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#scheme AppmeshRoute#scheme}.
     *
     * @stability stable
     */
    readonly scheme?: string;
    /**
     * header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#header AppmeshRoute#header}
     *
     * @stability stable
     */
    readonly header?: AppmeshRouteSpecHttpRouteMatchHeader[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_retry_events AppmeshRoute#http_retry_events}.
     *
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#max_retries AppmeshRoute#max_retries}.
     *
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_retry_events AppmeshRoute#tcp_retry_events}.
     *
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_retry_timeout AppmeshRoute#per_retry_timeout}
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeoutPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecHttpRouteTimeoutIdle[];
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_request AppmeshRoute#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecHttpRouteTimeoutPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecHttpRouteAction[];
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshRouteSpecHttpRouteMatch[];
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#retry_policy AppmeshRoute#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecHttpRouteRetryPolicy[];
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecHttpRouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecTcpRouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecTcpRouteTimeoutIdle[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecTcpRouteAction[];
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecTcpRouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#priority AppmeshRoute#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * grpc_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#grpc_route AppmeshRoute#grpc_route}
     *
     * @stability stable
     */
    readonly grpcRoute?: AppmeshRouteSpecGrpcRoute[];
    /**
     * http2_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http2_route AppmeshRoute#http2_route}
     *
     * @stability stable
     */
    readonly http2Route?: AppmeshRouteSpecHttp2Route[];
    /**
     * http_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_route AppmeshRoute#http_route}
     *
     * @stability stable
     */
    readonly httpRoute?: AppmeshRouteSpecHttpRoute[];
    /**
     * tcp_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_route AppmeshRoute#tcp_route}
     *
     * @stability stable
     */
    readonly tcpRoute?: AppmeshRouteSpecTcpRoute[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html aws_appmesh_route}.
 *
 * @stability stable
 */
export declare class AppmeshRoute extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html aws_appmesh_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshRouteConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _virtualRouterName;
    /**
     * @stability stable
     */
    get virtualRouterName(): string;
    /**
     * @stability stable
     */
    set virtualRouterName(value: string);
    /**
     * @stability stable
     */
    get virtualRouterNameInput(): string;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshRouteSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshRouteSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshRouteSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
