import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#comment CloudfrontOriginRequestPolicy#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#etag CloudfrontOriginRequestPolicy#etag}.
     *
     * @stability stable
     */
    readonly etag?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#name CloudfrontOriginRequestPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * cookies_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#cookies_config CloudfrontOriginRequestPolicy#cookies_config}
     *
     * @stability stable
     */
    readonly cookiesConfig: CloudfrontOriginRequestPolicyCookiesConfig[];
    /**
     * headers_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#headers_config CloudfrontOriginRequestPolicy#headers_config}
     *
     * @stability stable
     */
    readonly headersConfig: CloudfrontOriginRequestPolicyHeadersConfig[];
    /**
     * query_strings_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#query_strings_config CloudfrontOriginRequestPolicy#query_strings_config}
     *
     * @stability stable
     */
    readonly queryStringsConfig: CloudfrontOriginRequestPolicyQueryStringsConfig[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyCookiesConfigCookies {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#items CloudfrontOriginRequestPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyCookiesConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#cookie_behavior CloudfrontOriginRequestPolicy#cookie_behavior}.
     *
     * @stability stable
     */
    readonly cookieBehavior: string;
    /**
     * cookies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#cookies CloudfrontOriginRequestPolicy#cookies}
     *
     * @stability stable
     */
    readonly cookies?: CloudfrontOriginRequestPolicyCookiesConfigCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyHeadersConfigHeaders {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#items CloudfrontOriginRequestPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyHeadersConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#header_behavior CloudfrontOriginRequestPolicy#header_behavior}.
     *
     * @stability stable
     */
    readonly headerBehavior?: string;
    /**
     * headers block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#headers CloudfrontOriginRequestPolicy#headers}
     *
     * @stability stable
     */
    readonly headers?: CloudfrontOriginRequestPolicyHeadersConfigHeaders[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#items CloudfrontOriginRequestPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyQueryStringsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#query_string_behavior CloudfrontOriginRequestPolicy#query_string_behavior}.
     *
     * @stability stable
     */
    readonly queryStringBehavior: string;
    /**
     * query_strings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#query_strings CloudfrontOriginRequestPolicy#query_strings}
     *
     * @stability stable
     */
    readonly queryStrings?: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html aws_cloudfront_origin_request_policy}.
 *
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicy extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html aws_cloudfront_origin_request_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontOriginRequestPolicyConfig);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _etag?;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    set etag(value: string);
    /**
     * @stability stable
     */
    resetEtag(): void;
    /**
     * @stability stable
     */
    get etagInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _cookiesConfig;
    /**
     * @stability stable
     */
    get cookiesConfig(): CloudfrontOriginRequestPolicyCookiesConfig[];
    /**
     * @stability stable
     */
    set cookiesConfig(value: CloudfrontOriginRequestPolicyCookiesConfig[]);
    /**
     * @stability stable
     */
    get cookiesConfigInput(): CloudfrontOriginRequestPolicyCookiesConfig[];
    private _headersConfig;
    /**
     * @stability stable
     */
    get headersConfig(): CloudfrontOriginRequestPolicyHeadersConfig[];
    /**
     * @stability stable
     */
    set headersConfig(value: CloudfrontOriginRequestPolicyHeadersConfig[]);
    /**
     * @stability stable
     */
    get headersConfigInput(): CloudfrontOriginRequestPolicyHeadersConfig[];
    private _queryStringsConfig;
    /**
     * @stability stable
     */
    get queryStringsConfig(): CloudfrontOriginRequestPolicyQueryStringsConfig[];
    /**
     * @stability stable
     */
    set queryStringsConfig(value: CloudfrontOriginRequestPolicyQueryStringsConfig[]);
    /**
     * @stability stable
     */
    get queryStringsConfigInput(): CloudfrontOriginRequestPolicyQueryStringsConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
