import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#compute_platform CodedeployDeploymentConfig#compute_platform}.
     *
     * @stability stable
     */
    readonly computePlatform?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#deployment_config_name CodedeployDeploymentConfig#deployment_config_name}.
     *
     * @stability stable
     */
    readonly deploymentConfigName: string;
    /**
     * minimum_healthy_hosts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#minimum_healthy_hosts CodedeployDeploymentConfig#minimum_healthy_hosts}
     *
     * @stability stable
     */
    readonly minimumHealthyHosts?: CodedeployDeploymentConfigMinimumHealthyHosts[];
    /**
     * traffic_routing_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#traffic_routing_config CodedeployDeploymentConfig#traffic_routing_config}
     *
     * @stability stable
     */
    readonly trafficRoutingConfig?: CodedeployDeploymentConfigTrafficRoutingConfig[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigMinimumHealthyHosts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#type CodedeployDeploymentConfig#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#value CodedeployDeploymentConfig#value}.
     *
     * @stability stable
     */
    readonly value?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedCanary {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#interval CodedeployDeploymentConfig#interval}.
     *
     * @stability stable
     */
    readonly interval?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#percentage CodedeployDeploymentConfig#percentage}.
     *
     * @stability stable
     */
    readonly percentage?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedLinear {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#interval CodedeployDeploymentConfig#interval}.
     *
     * @stability stable
     */
    readonly interval?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#percentage CodedeployDeploymentConfig#percentage}.
     *
     * @stability stable
     */
    readonly percentage?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigTrafficRoutingConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#type CodedeployDeploymentConfig#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * time_based_canary block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#time_based_canary CodedeployDeploymentConfig#time_based_canary}
     *
     * @stability stable
     */
    readonly timeBasedCanary?: CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedCanary[];
    /**
     * time_based_linear block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html#time_based_linear CodedeployDeploymentConfig#time_based_linear}
     *
     * @stability stable
     */
    readonly timeBasedLinear?: CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedLinear[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html aws_codedeploy_deployment_config}.
 *
 * @stability stable
 */
export declare class CodedeployDeploymentConfig extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codedeploy_deployment_config.html aws_codedeploy_deployment_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodedeployDeploymentConfigConfig);
    private _computePlatform?;
    /**
     * @stability stable
     */
    get computePlatform(): string;
    /**
     * @stability stable
     */
    set computePlatform(value: string);
    /**
     * @stability stable
     */
    resetComputePlatform(): void;
    /**
     * @stability stable
     */
    get computePlatformInput(): string | undefined;
    /**
     * @stability stable
     */
    get deploymentConfigId(): string;
    private _deploymentConfigName;
    /**
     * @stability stable
     */
    get deploymentConfigName(): string;
    /**
     * @stability stable
     */
    set deploymentConfigName(value: string);
    /**
     * @stability stable
     */
    get deploymentConfigNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _minimumHealthyHosts?;
    /**
     * @stability stable
     */
    get minimumHealthyHosts(): CodedeployDeploymentConfigMinimumHealthyHosts[];
    /**
     * @stability stable
     */
    set minimumHealthyHosts(value: CodedeployDeploymentConfigMinimumHealthyHosts[]);
    /**
     * @stability stable
     */
    resetMinimumHealthyHosts(): void;
    /**
     * @stability stable
     */
    get minimumHealthyHostsInput(): CodedeployDeploymentConfigMinimumHealthyHosts[] | undefined;
    private _trafficRoutingConfig?;
    /**
     * @stability stable
     */
    get trafficRoutingConfig(): CodedeployDeploymentConfigTrafficRoutingConfig[];
    /**
     * @stability stable
     */
    set trafficRoutingConfig(value: CodedeployDeploymentConfigTrafficRoutingConfig[]);
    /**
     * @stability stable
     */
    resetTrafficRoutingConfig(): void;
    /**
     * @stability stable
     */
    get trafficRoutingConfigInput(): CodedeployDeploymentConfigTrafficRoutingConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
