import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCloudhsmV2ClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudhsm_v2_cluster.html#cluster_id DataAwsCloudhsmV2Cluster#cluster_id}.
     *
     * @stability stable
     */
    readonly clusterId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudhsm_v2_cluster.html#cluster_state DataAwsCloudhsmV2Cluster#cluster_state}.
     *
     * @stability stable
     */
    readonly clusterState?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudhsmV2ClusterClusterCertificates extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get awsHardwareCertificate(): string;
    /**
     * @stability stable
     */
    get clusterCertificate(): string;
    /**
     * @stability stable
     */
    get clusterCsr(): string;
    /**
     * @stability stable
     */
    get hsmCertificate(): string;
    /**
     * @stability stable
     */
    get manufacturerHardwareCertificate(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudhsm_v2_cluster.html aws_cloudhsm_v2_cluster}.
 *
 * @stability stable
 */
export declare class DataAwsCloudhsmV2Cluster extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudhsm_v2_cluster.html aws_cloudhsm_v2_cluster} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCloudhsmV2ClusterConfig);
    /**
     * @stability stable
     */
    clusterCertificates(index: string): DataAwsCloudhsmV2ClusterClusterCertificates;
    private _clusterId;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    set clusterId(value: string);
    /**
     * @stability stable
     */
    get clusterIdInput(): string;
    private _clusterState?;
    /**
     * @stability stable
     */
    get clusterState(): string;
    /**
     * @stability stable
     */
    set clusterState(value: string);
    /**
     * @stability stable
     */
    resetClusterState(): void;
    /**
     * @stability stable
     */
    get clusterStateInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get securityGroupId(): string;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
