import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEcsTaskDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecs_task_definition.html#task_definition DataAwsEcsTaskDefinition#task_definition}.
     *
     * @stability stable
     */
    readonly taskDefinition: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ecs_task_definition.html aws_ecs_task_definition}.
 *
 * @stability stable
 */
export declare class DataAwsEcsTaskDefinition extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ecs_task_definition.html aws_ecs_task_definition} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEcsTaskDefinitionConfig);
    /**
     * @stability stable
     */
    get family(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get networkMode(): string;
    /**
     * @stability stable
     */
    get revision(): number;
    /**
     * @stability stable
     */
    get status(): string;
    private _taskDefinition;
    /**
     * @stability stable
     */
    get taskDefinition(): string;
    /**
     * @stability stable
     */
    set taskDefinition(value: string);
    /**
     * @stability stable
     */
    get taskDefinitionInput(): string;
    /**
     * @stability stable
     */
    get taskRoleArn(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
