import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsGlueScriptConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#language DataAwsGlueScript#language}.
     *
     * @stability stable
     */
    readonly language?: string;
    /**
     * dag_edge block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#dag_edge DataAwsGlueScript#dag_edge}
     *
     * @stability stable
     */
    readonly dagEdge: DataAwsGlueScriptDagEdge[];
    /**
     * dag_node block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#dag_node DataAwsGlueScript#dag_node}
     *
     * @stability stable
     */
    readonly dagNode: DataAwsGlueScriptDagNode[];
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagEdge {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#source DataAwsGlueScript#source}.
     *
     * @stability stable
     */
    readonly source: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#target DataAwsGlueScript#target}.
     *
     * @stability stable
     */
    readonly target: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#target_parameter DataAwsGlueScript#target_parameter}.
     *
     * @stability stable
     */
    readonly targetParameter?: string;
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagNodeArgs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#name DataAwsGlueScript#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#param DataAwsGlueScript#param}.
     *
     * @stability stable
     */
    readonly param?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#value DataAwsGlueScript#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagNode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#id DataAwsGlueScript#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#line_number DataAwsGlueScript#line_number}.
     *
     * @stability stable
     */
    readonly lineNumber?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#node_type DataAwsGlueScript#node_type}.
     *
     * @stability stable
     */
    readonly nodeType: string;
    /**
     * args block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html#args DataAwsGlueScript#args}
     *
     * @stability stable
     */
    readonly args: DataAwsGlueScriptDagNodeArgs[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html aws_glue_script}.
 *
 * @stability stable
 */
export declare class DataAwsGlueScript extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/glue_script.html aws_glue_script} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsGlueScriptConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _language?;
    /**
     * @stability stable
     */
    get language(): string;
    /**
     * @stability stable
     */
    set language(value: string);
    /**
     * @stability stable
     */
    resetLanguage(): void;
    /**
     * @stability stable
     */
    get languageInput(): string | undefined;
    /**
     * @stability stable
     */
    get pythonScript(): string;
    /**
     * @stability stable
     */
    get scalaCode(): string;
    private _dagEdge;
    /**
     * @stability stable
     */
    get dagEdge(): DataAwsGlueScriptDagEdge[];
    /**
     * @stability stable
     */
    set dagEdge(value: DataAwsGlueScriptDagEdge[]);
    /**
     * @stability stable
     */
    get dagEdgeInput(): DataAwsGlueScriptDagEdge[];
    private _dagNode;
    /**
     * @stability stable
     */
    get dagNode(): DataAwsGlueScriptDagNode[];
    /**
     * @stability stable
     */
    set dagNode(value: DataAwsGlueScriptDagNode[]);
    /**
     * @stability stable
     */
    get dagNodeInput(): DataAwsGlueScriptDagNode[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
