import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#override_json DataAwsIamPolicyDocument#override_json}.
     *
     * @stability stable
     */
    readonly overrideJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#override_policy_documents DataAwsIamPolicyDocument#override_policy_documents}.
     *
     * @stability stable
     */
    readonly overridePolicyDocuments?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#policy_id DataAwsIamPolicyDocument#policy_id}.
     *
     * @stability stable
     */
    readonly policyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#source_json DataAwsIamPolicyDocument#source_json}.
     *
     * @stability stable
     */
    readonly sourceJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#source_policy_documents DataAwsIamPolicyDocument#source_policy_documents}.
     *
     * @stability stable
     */
    readonly sourcePolicyDocuments?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#version DataAwsIamPolicyDocument#version}.
     *
     * @stability stable
     */
    readonly version?: string;
    /**
     * statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#statement DataAwsIamPolicyDocument#statement}
     *
     * @stability stable
     */
    readonly statement?: DataAwsIamPolicyDocumentStatement[];
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatementCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#test DataAwsIamPolicyDocument#test}.
     *
     * @stability stable
     */
    readonly test: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#values DataAwsIamPolicyDocument#values}.
     *
     * @stability stable
     */
    readonly values: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#variable DataAwsIamPolicyDocument#variable}.
     *
     * @stability stable
     */
    readonly variable: string;
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatementNotPrincipals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#identifiers DataAwsIamPolicyDocument#identifiers}.
     *
     * @stability stable
     */
    readonly identifiers: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#type DataAwsIamPolicyDocument#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatementPrincipals {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#identifiers DataAwsIamPolicyDocument#identifiers}.
     *
     * @stability stable
     */
    readonly identifiers: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#type DataAwsIamPolicyDocument#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#actions DataAwsIamPolicyDocument#actions}.
     *
     * @stability stable
     */
    readonly actions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#effect DataAwsIamPolicyDocument#effect}.
     *
     * @stability stable
     */
    readonly effect?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#not_actions DataAwsIamPolicyDocument#not_actions}.
     *
     * @stability stable
     */
    readonly notActions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#not_resources DataAwsIamPolicyDocument#not_resources}.
     *
     * @stability stable
     */
    readonly notResources?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#resources DataAwsIamPolicyDocument#resources}.
     *
     * @stability stable
     */
    readonly resources?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#sid DataAwsIamPolicyDocument#sid}.
     *
     * @stability stable
     */
    readonly sid?: string;
    /**
     * condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#condition DataAwsIamPolicyDocument#condition}
     *
     * @stability stable
     */
    readonly condition?: DataAwsIamPolicyDocumentStatementCondition[];
    /**
     * not_principals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#not_principals DataAwsIamPolicyDocument#not_principals}
     *
     * @stability stable
     */
    readonly notPrincipals?: DataAwsIamPolicyDocumentStatementNotPrincipals[];
    /**
     * principals block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html#principals DataAwsIamPolicyDocument#principals}
     *
     * @stability stable
     */
    readonly principals?: DataAwsIamPolicyDocumentStatementPrincipals[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html aws_iam_policy_document}.
 *
 * @stability stable
 */
export declare class DataAwsIamPolicyDocument extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/iam_policy_document.html aws_iam_policy_document} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsIamPolicyDocumentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get json(): string;
    private _overrideJson?;
    /**
     * @stability stable
     */
    get overrideJson(): string;
    /**
     * @stability stable
     */
    set overrideJson(value: string);
    /**
     * @stability stable
     */
    resetOverrideJson(): void;
    /**
     * @stability stable
     */
    get overrideJsonInput(): string | undefined;
    private _overridePolicyDocuments?;
    /**
     * @stability stable
     */
    get overridePolicyDocuments(): string[];
    /**
     * @stability stable
     */
    set overridePolicyDocuments(value: string[]);
    /**
     * @stability stable
     */
    resetOverridePolicyDocuments(): void;
    /**
     * @stability stable
     */
    get overridePolicyDocumentsInput(): string[] | undefined;
    private _policyId?;
    /**
     * @stability stable
     */
    get policyId(): string;
    /**
     * @stability stable
     */
    set policyId(value: string);
    /**
     * @stability stable
     */
    resetPolicyId(): void;
    /**
     * @stability stable
     */
    get policyIdInput(): string | undefined;
    private _sourceJson?;
    /**
     * @stability stable
     */
    get sourceJson(): string;
    /**
     * @stability stable
     */
    set sourceJson(value: string);
    /**
     * @stability stable
     */
    resetSourceJson(): void;
    /**
     * @stability stable
     */
    get sourceJsonInput(): string | undefined;
    private _sourcePolicyDocuments?;
    /**
     * @stability stable
     */
    get sourcePolicyDocuments(): string[];
    /**
     * @stability stable
     */
    set sourcePolicyDocuments(value: string[]);
    /**
     * @stability stable
     */
    resetSourcePolicyDocuments(): void;
    /**
     * @stability stable
     */
    get sourcePolicyDocumentsInput(): string[] | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _statement?;
    /**
     * @stability stable
     */
    get statement(): DataAwsIamPolicyDocumentStatement[];
    /**
     * @stability stable
     */
    set statement(value: DataAwsIamPolicyDocumentStatement[]);
    /**
     * @stability stable
     */
    resetStatement(): void;
    /**
     * @stability stable
     */
    get statementInput(): DataAwsIamPolicyDocumentStatement[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
