import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueUserDefinedFunctionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#catalog_id GlueUserDefinedFunction#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#class_name GlueUserDefinedFunction#class_name}.
     *
     * @stability stable
     */
    readonly className: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#database_name GlueUserDefinedFunction#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#name GlueUserDefinedFunction#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#owner_name GlueUserDefinedFunction#owner_name}.
     *
     * @stability stable
     */
    readonly ownerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#owner_type GlueUserDefinedFunction#owner_type}.
     *
     * @stability stable
     */
    readonly ownerType: string;
    /**
     * resource_uris block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#resource_uris GlueUserDefinedFunction#resource_uris}
     *
     * @stability stable
     */
    readonly resourceUris?: GlueUserDefinedFunctionResourceUris[];
}
/**
 * @stability stable
 */
export interface GlueUserDefinedFunctionResourceUris {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#resource_type GlueUserDefinedFunction#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html#uri GlueUserDefinedFunction#uri}.
     *
     * @stability stable
     */
    readonly uri: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html aws_glue_user_defined_function}.
 *
 * @stability stable
 */
export declare class GlueUserDefinedFunction extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_user_defined_function.html aws_glue_user_defined_function} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueUserDefinedFunctionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _className;
    /**
     * @stability stable
     */
    get className(): string;
    /**
     * @stability stable
     */
    set className(value: string);
    /**
     * @stability stable
     */
    get classNameInput(): string;
    /**
     * @stability stable
     */
    get createTime(): string;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _ownerName;
    /**
     * @stability stable
     */
    get ownerName(): string;
    /**
     * @stability stable
     */
    set ownerName(value: string);
    /**
     * @stability stable
     */
    get ownerNameInput(): string;
    private _ownerType;
    /**
     * @stability stable
     */
    get ownerType(): string;
    /**
     * @stability stable
     */
    set ownerType(value: string);
    /**
     * @stability stable
     */
    get ownerTypeInput(): string;
    private _resourceUris?;
    /**
     * @stability stable
     */
    get resourceUris(): GlueUserDefinedFunctionResourceUris[];
    /**
     * @stability stable
     */
    set resourceUris(value: GlueUserDefinedFunctionResourceUris[]);
    /**
     * @stability stable
     */
    resetResourceUris(): void;
    /**
     * @stability stable
     */
    get resourceUrisInput(): GlueUserDefinedFunctionResourceUris[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
