import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MskClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#cluster_name MskCluster#cluster_name}.
     *
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#enhanced_monitoring MskCluster#enhanced_monitoring}.
     *
     * @stability stable
     */
    readonly enhancedMonitoring?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#kafka_version MskCluster#kafka_version}.
     *
     * @stability stable
     */
    readonly kafkaVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#number_of_broker_nodes MskCluster#number_of_broker_nodes}.
     *
     * @stability stable
     */
    readonly numberOfBrokerNodes: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#tags MskCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#tags_all MskCluster#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * broker_node_group_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#broker_node_group_info MskCluster#broker_node_group_info}
     *
     * @stability stable
     */
    readonly brokerNodeGroupInfo: MskClusterBrokerNodeGroupInfo[];
    /**
     * client_authentication block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#client_authentication MskCluster#client_authentication}
     *
     * @stability stable
     */
    readonly clientAuthentication?: MskClusterClientAuthentication[];
    /**
     * configuration_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#configuration_info MskCluster#configuration_info}
     *
     * @stability stable
     */
    readonly configurationInfo?: MskClusterConfigurationInfo[];
    /**
     * encryption_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#encryption_info MskCluster#encryption_info}
     *
     * @stability stable
     */
    readonly encryptionInfo?: MskClusterEncryptionInfo[];
    /**
     * logging_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#logging_info MskCluster#logging_info}
     *
     * @stability stable
     */
    readonly loggingInfo?: MskClusterLoggingInfo[];
    /**
     * open_monitoring block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#open_monitoring MskCluster#open_monitoring}
     *
     * @stability stable
     */
    readonly openMonitoring?: MskClusterOpenMonitoring[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#timeouts MskCluster#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MskClusterTimeouts;
}
/**
 * @stability stable
 */
export interface MskClusterBrokerNodeGroupInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#az_distribution MskCluster#az_distribution}.
     *
     * @stability stable
     */
    readonly azDistribution?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#client_subnets MskCluster#client_subnets}.
     *
     * @stability stable
     */
    readonly clientSubnets: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#ebs_volume_size MskCluster#ebs_volume_size}.
     *
     * @stability stable
     */
    readonly ebsVolumeSize: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#instance_type MskCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#security_groups MskCluster#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups: string[];
}
/**
 * @stability stable
 */
export interface MskClusterClientAuthenticationSasl {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#iam MskCluster#iam}.
     *
     * @stability stable
     */
    readonly iam?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#scram MskCluster#scram}.
     *
     * @stability stable
     */
    readonly scram?: boolean;
}
/**
 * @stability stable
 */
export interface MskClusterClientAuthenticationTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#certificate_authority_arns MskCluster#certificate_authority_arns}.
     *
     * @stability stable
     */
    readonly certificateAuthorityArns?: string[];
}
/**
 * @stability stable
 */
export interface MskClusterClientAuthentication {
    /**
     * sasl block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#sasl MskCluster#sasl}
     *
     * @stability stable
     */
    readonly sasl?: MskClusterClientAuthenticationSasl[];
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#tls MskCluster#tls}
     *
     * @stability stable
     */
    readonly tls?: MskClusterClientAuthenticationTls[];
}
/**
 * @stability stable
 */
export interface MskClusterConfigurationInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#arn MskCluster#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#revision MskCluster#revision}.
     *
     * @stability stable
     */
    readonly revision: number;
}
/**
 * @stability stable
 */
export interface MskClusterEncryptionInfoEncryptionInTransit {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#client_broker MskCluster#client_broker}.
     *
     * @stability stable
     */
    readonly clientBroker?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#in_cluster MskCluster#in_cluster}.
     *
     * @stability stable
     */
    readonly inCluster?: boolean;
}
/**
 * @stability stable
 */
export interface MskClusterEncryptionInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#encryption_at_rest_kms_key_arn MskCluster#encryption_at_rest_kms_key_arn}.
     *
     * @stability stable
     */
    readonly encryptionAtRestKmsKeyArn?: string;
    /**
     * encryption_in_transit block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#encryption_in_transit MskCluster#encryption_in_transit}
     *
     * @stability stable
     */
    readonly encryptionInTransit?: MskClusterEncryptionInfoEncryptionInTransit[];
}
/**
 * @stability stable
 */
export interface MskClusterLoggingInfoBrokerLogsCloudwatchLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#enabled MskCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#log_group MskCluster#log_group}.
     *
     * @stability stable
     */
    readonly logGroup?: string;
}
/**
 * @stability stable
 */
export interface MskClusterLoggingInfoBrokerLogsFirehose {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#delivery_stream MskCluster#delivery_stream}.
     *
     * @stability stable
     */
    readonly deliveryStream?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#enabled MskCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface MskClusterLoggingInfoBrokerLogsS3 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#bucket MskCluster#bucket}.
     *
     * @stability stable
     */
    readonly bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#enabled MskCluster#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#prefix MskCluster#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
}
/**
 * @stability stable
 */
export interface MskClusterLoggingInfoBrokerLogs {
    /**
     * cloudwatch_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#cloudwatch_logs MskCluster#cloudwatch_logs}
     *
     * @stability stable
     */
    readonly cloudwatchLogs?: MskClusterLoggingInfoBrokerLogsCloudwatchLogs[];
    /**
     * firehose block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#firehose MskCluster#firehose}
     *
     * @stability stable
     */
    readonly firehose?: MskClusterLoggingInfoBrokerLogsFirehose[];
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#s3 MskCluster#s3}
     *
     * @stability stable
     */
    readonly s3?: MskClusterLoggingInfoBrokerLogsS3[];
}
/**
 * @stability stable
 */
export interface MskClusterLoggingInfo {
    /**
     * broker_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#broker_logs MskCluster#broker_logs}
     *
     * @stability stable
     */
    readonly brokerLogs: MskClusterLoggingInfoBrokerLogs[];
}
/**
 * @stability stable
 */
export interface MskClusterOpenMonitoringPrometheusJmxExporter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#enabled_in_broker MskCluster#enabled_in_broker}.
     *
     * @stability stable
     */
    readonly enabledInBroker: boolean;
}
/**
 * @stability stable
 */
export interface MskClusterOpenMonitoringPrometheusNodeExporter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#enabled_in_broker MskCluster#enabled_in_broker}.
     *
     * @stability stable
     */
    readonly enabledInBroker: boolean;
}
/**
 * @stability stable
 */
export interface MskClusterOpenMonitoringPrometheus {
    /**
     * jmx_exporter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#jmx_exporter MskCluster#jmx_exporter}
     *
     * @stability stable
     */
    readonly jmxExporter?: MskClusterOpenMonitoringPrometheusJmxExporter[];
    /**
     * node_exporter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#node_exporter MskCluster#node_exporter}
     *
     * @stability stable
     */
    readonly nodeExporter?: MskClusterOpenMonitoringPrometheusNodeExporter[];
}
/**
 * @stability stable
 */
export interface MskClusterOpenMonitoring {
    /**
     * prometheus block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#prometheus MskCluster#prometheus}
     *
     * @stability stable
     */
    readonly prometheus: MskClusterOpenMonitoringPrometheus[];
}
/**
 * @stability stable
 */
export interface MskClusterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#create MskCluster#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#delete MskCluster#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html#update MskCluster#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html aws_msk_cluster}.
 *
 * @stability stable
 */
export declare class MskCluster extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/msk_cluster.html aws_msk_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MskClusterConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get bootstrapBrokers(): string;
    /**
     * @stability stable
     */
    get bootstrapBrokersSaslIam(): string;
    /**
     * @stability stable
     */
    get bootstrapBrokersSaslScram(): string;
    /**
     * @stability stable
     */
    get bootstrapBrokersTls(): string;
    private _clusterName;
    /**
     * @stability stable
     */
    get clusterName(): string;
    /**
     * @stability stable
     */
    set clusterName(value: string);
    /**
     * @stability stable
     */
    get clusterNameInput(): string;
    /**
     * @stability stable
     */
    get currentVersion(): string;
    private _enhancedMonitoring?;
    /**
     * @stability stable
     */
    get enhancedMonitoring(): string;
    /**
     * @stability stable
     */
    set enhancedMonitoring(value: string);
    /**
     * @stability stable
     */
    resetEnhancedMonitoring(): void;
    /**
     * @stability stable
     */
    get enhancedMonitoringInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kafkaVersion;
    /**
     * @stability stable
     */
    get kafkaVersion(): string;
    /**
     * @stability stable
     */
    set kafkaVersion(value: string);
    /**
     * @stability stable
     */
    get kafkaVersionInput(): string;
    private _numberOfBrokerNodes;
    /**
     * @stability stable
     */
    get numberOfBrokerNodes(): number;
    /**
     * @stability stable
     */
    set numberOfBrokerNodes(value: number);
    /**
     * @stability stable
     */
    get numberOfBrokerNodesInput(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get zookeeperConnectString(): string;
    private _brokerNodeGroupInfo;
    /**
     * @stability stable
     */
    get brokerNodeGroupInfo(): MskClusterBrokerNodeGroupInfo[];
    /**
     * @stability stable
     */
    set brokerNodeGroupInfo(value: MskClusterBrokerNodeGroupInfo[]);
    /**
     * @stability stable
     */
    get brokerNodeGroupInfoInput(): MskClusterBrokerNodeGroupInfo[];
    private _clientAuthentication?;
    /**
     * @stability stable
     */
    get clientAuthentication(): MskClusterClientAuthentication[];
    /**
     * @stability stable
     */
    set clientAuthentication(value: MskClusterClientAuthentication[]);
    /**
     * @stability stable
     */
    resetClientAuthentication(): void;
    /**
     * @stability stable
     */
    get clientAuthenticationInput(): MskClusterClientAuthentication[] | undefined;
    private _configurationInfo?;
    /**
     * @stability stable
     */
    get configurationInfo(): MskClusterConfigurationInfo[];
    /**
     * @stability stable
     */
    set configurationInfo(value: MskClusterConfigurationInfo[]);
    /**
     * @stability stable
     */
    resetConfigurationInfo(): void;
    /**
     * @stability stable
     */
    get configurationInfoInput(): MskClusterConfigurationInfo[] | undefined;
    private _encryptionInfo?;
    /**
     * @stability stable
     */
    get encryptionInfo(): MskClusterEncryptionInfo[];
    /**
     * @stability stable
     */
    set encryptionInfo(value: MskClusterEncryptionInfo[]);
    /**
     * @stability stable
     */
    resetEncryptionInfo(): void;
    /**
     * @stability stable
     */
    get encryptionInfoInput(): MskClusterEncryptionInfo[] | undefined;
    private _loggingInfo?;
    /**
     * @stability stable
     */
    get loggingInfo(): MskClusterLoggingInfo[];
    /**
     * @stability stable
     */
    set loggingInfo(value: MskClusterLoggingInfo[]);
    /**
     * @stability stable
     */
    resetLoggingInfo(): void;
    /**
     * @stability stable
     */
    get loggingInfoInput(): MskClusterLoggingInfo[] | undefined;
    private _openMonitoring?;
    /**
     * @stability stable
     */
    get openMonitoring(): MskClusterOpenMonitoring[];
    /**
     * @stability stable
     */
    set openMonitoring(value: MskClusterOpenMonitoring[]);
    /**
     * @stability stable
     */
    resetOpenMonitoring(): void;
    /**
     * @stability stable
     */
    get openMonitoringInput(): MskClusterOpenMonitoring[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): MskClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: MskClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MskClusterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
