import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MskScramSecretAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_scram_secret_association.html#cluster_arn MskScramSecretAssociation#cluster_arn}.
     *
     * @stability stable
     */
    readonly clusterArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/msk_scram_secret_association.html#secret_arn_list MskScramSecretAssociation#secret_arn_list}.
     *
     * @stability stable
     */
    readonly secretArnList: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/msk_scram_secret_association.html aws_msk_scram_secret_association}.
 *
 * @stability stable
 */
export declare class MskScramSecretAssociation extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/msk_scram_secret_association.html aws_msk_scram_secret_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MskScramSecretAssociationConfig);
    private _clusterArn;
    /**
     * @stability stable
     */
    get clusterArn(): string;
    /**
     * @stability stable
     */
    set clusterArn(value: string);
    /**
     * @stability stable
     */
    get clusterArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _secretArnList;
    /**
     * @stability stable
     */
    get secretArnList(): string[];
    /**
     * @stability stable
     */
    set secretArnList(value: string[]);
    /**
     * @stability stable
     */
    get secretArnListInput(): string[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
