import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#firewall_arn NetworkfirewallLoggingConfiguration#firewall_arn}.
     *
     * @stability stable
     */
    readonly firewallArn: string;
    /**
     * logging_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#logging_configuration NetworkfirewallLoggingConfiguration#logging_configuration}
     *
     * @stability stable
     */
    readonly loggingConfiguration: NetworkfirewallLoggingConfigurationLoggingConfiguration[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_destination NetworkfirewallLoggingConfiguration#log_destination}.
     *
     * @stability stable
     */
    readonly logDestination: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_destination_type NetworkfirewallLoggingConfiguration#log_destination_type}.
     *
     * @stability stable
     */
    readonly logDestinationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_type NetworkfirewallLoggingConfiguration#log_type}.
     *
     * @stability stable
     */
    readonly logType: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationLoggingConfiguration {
    /**
     * log_destination_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_destination_config NetworkfirewallLoggingConfiguration#log_destination_config}
     *
     * @stability stable
     */
    readonly logDestinationConfig: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html aws_networkfirewall_logging_configuration}.
 *
 * @stability stable
 */
export declare class NetworkfirewallLoggingConfiguration extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html aws_networkfirewall_logging_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallLoggingConfigurationConfig);
    private _firewallArn;
    /**
     * @stability stable
     */
    get firewallArn(): string;
    /**
     * @stability stable
     */
    set firewallArn(value: string);
    /**
     * @stability stable
     */
    get firewallArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _loggingConfiguration;
    /**
     * @stability stable
     */
    get loggingConfiguration(): NetworkfirewallLoggingConfigurationLoggingConfiguration[];
    /**
     * @stability stable
     */
    set loggingConfiguration(value: NetworkfirewallLoggingConfigurationLoggingConfiguration[]);
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): NetworkfirewallLoggingConfigurationLoggingConfiguration[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
