import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerAppConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#app_name SagemakerApp#app_name}.
     *
     * @stability stable
     */
    readonly appName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#app_type SagemakerApp#app_type}.
     *
     * @stability stable
     */
    readonly appType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#domain_id SagemakerApp#domain_id}.
     *
     * @stability stable
     */
    readonly domainId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#tags SagemakerApp#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#tags_all SagemakerApp#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#user_profile_name SagemakerApp#user_profile_name}.
     *
     * @stability stable
     */
    readonly userProfileName: string;
    /**
     * resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#resource_spec SagemakerApp#resource_spec}
     *
     * @stability stable
     */
    readonly resourceSpec?: SagemakerAppResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerAppResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#instance_type SagemakerApp#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html#sagemaker_image_arn SagemakerApp#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html aws_sagemaker_app}.
 *
 * @stability stable
 */
export declare class SagemakerApp extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app.html aws_sagemaker_app} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerAppConfig);
    private _appName;
    /**
     * @stability stable
     */
    get appName(): string;
    /**
     * @stability stable
     */
    set appName(value: string);
    /**
     * @stability stable
     */
    get appNameInput(): string;
    private _appType;
    /**
     * @stability stable
     */
    get appType(): string;
    /**
     * @stability stable
     */
    set appType(value: string);
    /**
     * @stability stable
     */
    get appTypeInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainId;
    /**
     * @stability stable
     */
    get domainId(): string;
    /**
     * @stability stable
     */
    set domainId(value: string);
    /**
     * @stability stable
     */
    get domainIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _userProfileName;
    /**
     * @stability stable
     */
    get userProfileName(): string;
    /**
     * @stability stable
     */
    set userProfileName(value: string);
    /**
     * @stability stable
     */
    get userProfileNameInput(): string;
    private _resourceSpec?;
    /**
     * @stability stable
     */
    get resourceSpec(): SagemakerAppResourceSpec[];
    /**
     * @stability stable
     */
    set resourceSpec(value: SagemakerAppResourceSpec[]);
    /**
     * @stability stable
     */
    resetResourceSpec(): void;
    /**
     * @stability stable
     */
    get resourceSpecInput(): SagemakerAppResourceSpec[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
